//
//  MWMath.h
//  Malkinware
//
//  Created by Jim McGowan on 18/02/2010.
//  Copyright 2010 Jim McGowan. All rights reserved.
//

#import <Foundation/Foundation.h>


BOOL isOdd(NSInteger value);
BOOL isOddF(CGFloat value);
BOOL isEven(NSInteger value);
BOOL isEvenF(CGFloat value);

CGFloat greatestOfThreeCGFloats(CGFloat f1, CGFloat f2, CGFloat f3);

long nearestGreaterPowerOfTwo(long x);

double constrainDouble(double value, double lowerLimit, double upperLimit);
float constrainFloat(float value, float lowerLimit, float upperLimit);
CGFloat constrainCGFloat(CGFloat value, CGFloat lowerLimit, CGFloat upperLimit);

// Converting between Frequency in Hertz to Angular Frequency in Radians per Second
double hertzToRadiansPerSecond(double freqInHz);
double radiansPerSecondToHertz(double radsPerSec);


// Dealing with nan and inf
bool containsNaN(float* array, UInt32 length);
UInt32 replaceNaN(float *array, UInt32 length, float replacementValue);
bool containsInf(float* array, UInt32 length);
UInt32 replaceInf(float *array, UInt32 length, float replacementValue);